/*
 *  Copyright (c) 2019, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied. See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */

package io.siddhi.extension.io.s3.sink.internal.publisher;

import io.siddhi.extension.io.s3.sink.internal.ServiceClient;
import org.apache.log4j.Logger;

/**
 * {@code PublisherTask} is responsible for each event object to be uploaded to a S3 bucket.
 */
public class PublisherTask implements Runnable {
    private static final Logger logger = Logger.getLogger(PublisherTask.class);

    private final ServiceClient client;
    private final int offset;

    private Object payload;
    private String objectPath;

    public PublisherTask(ServiceClient client, String objectPath, Object payload, int offset) {
        this.client = client;
        this.objectPath = objectPath;
        this.payload = payload;
        this.offset = offset;
    }

    @Override
    public void run() {
        client.uploadObject(objectPath, payload, offset);
    }
}
